<?php
/*
http://www.payline.com
Payline module for Virtuemart 2.0.x - v2.0 - September 2012
Copyright (C) 2012 Monext. All rights reserved.
*/

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_ADMINISTRATOR.DS.'plugins'.DS.'vmpsplugin.php');

if (!class_exists( 'VmConfig' ))
require(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart'.DS.'helpers'.DS.'config.php');

if (!class_exists('VirtueMartModelOrders'))
require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

if (!class_exists('VirtueMartCart'))
require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');

require(JPATH_PLUGINS.DS.'vmpayment'.DS.'payline'.DS.'conf'.DS.'options.php');
require(JPATH_PLUGINS.DS.'vmpayment'.DS.'payline'.DS.'lib'.DS.'paylineSDK.php');

class plgVmPaymentPayline extends vmPSPlugin {

	private $errorMessage;
	private $paylineSDK;

	var $_pelement;

	public static $_this = false;

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);

		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());

		$varsToPush = $this->getVarsToPush();
		$varsToPush['payment_logos'] = array('', 'char');

		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);

	}
	
	private function traceQuery($db){
		if($db->getErrorNum() != 0){
			if($this->paylineSDK != null){
				$this->paylineSDK->writeTrace('ERROR : '.$db->getErrorMsg(true));
			}else{
				$paylineLog = new PaylineLog(date('Y-m-d',time()).'.log');
				$paylineLog->write('ERROR : '.$db->getErrorMsg(true));
				
			}
		}
	}
	
	private function _formatToUtf8($inString){
		$cur_encoding = mb_detect_encoding($inString) ;
		if($cur_encoding == "UTF-8" && mb_check_encoding($inString,"UTF-8")){
			$outString = $inString;
		}else{
			$outString = utf8_encode($inString);
		}
		return $outString;
	}

	protected function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment Payline Table');
	}

	function getTableSQLFields() {
		$SQLfields = array(
	    'id' => ' int(1) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' => ' int(11) UNSIGNED DEFAULT NULL',
	    'order_number' => ' char(32) DEFAULT NULL',
	    'payment_total' => 'int(9)',
		'payment_currency' => 'int(3)',
		'order_total' => 'int(9)',
	    'order_currency' => 'int(3)',
		'action' => 'int(3)',
	    'token' => 'varchar(50)',
		'status' => 'varchar(50)',
		'return_code' => 'varchar(5)',
		'contract' => 'varchar(30)',
		'transaction' => 'varchar(50)',
		'card_num' => 'varchar(30)',
		'card_type' => 'varchar(30)',
		'card_exp' => 'varchar(8)'
		);
		return $SQLfields;
	}

	

	function plgVmConfirmedOrder($cart, $order) {

		$order_number =  $order['details']['BT']->order_number;
		$virtuemart_order_id = $order['details']['BT']->virtuemart_order_id;

		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null;
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}

		$db = JFactory::getDBO();

		$query = $db->getQuery(true);
		$query->select('country_name')->from('#__virtuemart_countries')->where('virtuemart_country_id='.$order['details']['BT']->virtuemart_country_id);
		$db->setQuery($query);
		$countryName = $db->loadResult();

		$query->clear();
		$query->select('currency_numeric_code')->from('#__virtuemart_currencies')->where('virtuemart_currency_id='.$method->payment_currency);
		$db->setQuery($query);
		$paymentCurrencyCode = $db->loadResult();

		$query->clear();
		$query->select('currency_numeric_code')->from('#__virtuemart_currencies')->where('virtuemart_currency_id='.$order['details']['BT']->order_currency);
		$db->setQuery($query);
		$orderCurrencyCode = $db->loadResult();

		$currencyDisplay = CurrencyDisplay::getInstance ($method->payment_currency);
		$totalInPaymentCurrency = round(100*$currencyDisplay->convertCurrencyTo ($method->payment_currency, $order['details']['BT']->order_total, FALSE));
		$totalInOrderCurrency = round(100*$currencyDisplay->convertCurrencyTo ($order['details']['BT']->order_currency, $order['details']['BT']->order_total, FALSE));

		$dbValues = array(
			'virtuemart_order_id' => $virtuemart_order_id,
			'order_number' => $order_number,
			'payment_total' => $totalInPaymentCurrency,
			'payment_currency' => $paymentCurrencyCode,
			'order_total' => $totalInOrderCurrency,
			'order_currency' => $orderCurrencyCode,
			'status' => 'INIT',
			'action' => $method->payment_action
		);
		$this->storePSPluginInternalData($dbValues);

		$this->paylineSDK = new paylineSDK(
		$method->merchant_id,
		$method->access_key,
		$method->proxy_host,
		$method->proxy_port,
		$method->proxy_login,
		$method->proxy_password,
		$method->environment
		);

		$this->paylineSDK->returnURL		= JROUTE::_ (JURI::root () . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id );
		$this->paylineSDK->cancelURL		= $this->paylineSDK->returnURL;
		$this->paylineSDK->notificationURL	= $this->paylineSDK->returnURL;

		$doWebPaymentParams = array();
		$doWebPaymentParams['payment']['action']			= $method->payment_action;
		$doWebPaymentParams['payment']['mode']				= 'CPT';
		$doWebPaymentParams['payment']['amount']			= $totalInPaymentCurrency;
		$doWebPaymentParams['payment']['currency']			= $paymentCurrencyCode;

		$doWebPaymentParams['contracts']					= explode(';',$method->primary_contracts);
		$doWebPaymentParams['secondContracts']				= explode(';',$method->secondary_contracts);
		$doWebPaymentParams['payment']['contractNumber']	= $doWebPaymentParams['contracts'][0];

		$doWebPaymentParams['customPaymentTemplateURL']		= $method->template_url;
		$doWebPaymentParams['customPaymentPageCode']		= $method->custom_page_code;

		$doWebPaymentParams['order']['ref']					= $order_number;
		$doWebPaymentParams['order']['amount']				= $totalInOrderCurrency;
		$doWebPaymentParams['order']['currency']			=  $orderCurrencyCode;
		$doWebPaymentParams['order']['origin']				= 1 ;
		$doWebPaymentParams['order']['country']				= '';
		$doWebPaymentParams['order']['date']				= date('d/m/Y H:i',time());

		foreach ($cart->products as $product) {
			$order_detail = array();
			$order_detail['ref']		= $product->product_name;
			$order_detail['price']		= round(100*$currencyDisplay->convertCurrencyTo ($order['details']['BT']->order_currency, $product->product_price, FALSE));
			$order_detail['quantity']	= $product->quantity;
			$this->paylineSDK->setItem($order_detail);
		}

		$doWebPaymentParams['buyer']['lastName']	= $this->_formatToUtf8($order['details']['BT']->last_name);
		$doWebPaymentParams['buyer']['firstName']	= $this->_formatToUtf8($order['details']['BT']->first_name);
		$doWebPaymentParams['buyer']['email']		= $order['details']['BT']->email;
		$doWebPaymentParams['buyer']['ip']			= $order['details']['BT']->ip_address;

		$doWebPaymentParams['address']['name']		= '';
		$doWebPaymentParams['address']['street1']	= $order['details']['BT']->address_1;
		$doWebPaymentParams['address']['street2']	= $order['details']['BT']->address_2;
		$doWebPaymentParams['address']['cityName']	= $order['details']['BT']->city;
		$doWebPaymentParams['address']['zipCode']	= $order['details']['BT']->zip;
		$doWebPaymentParams['address']['country']	= $countryName;
		$forbidenCars = array(' ','.','(',')','-');
		$doWebPaymentParams['address']['phone']		= str_replace($forbidenCars,'',$order['details']['BT']->phone_1);

		$doWebPaymentResponse = $this->paylineSDK->doWebPayment($doWebPaymentParams);

		if(isset($doWebPaymentResponse) && isset($doWebPaymentResponse['result']['code'])){
			if($doWebPaymentResponse['result']['code'] == '00000'){
				$this->paylineSDK->writeTrace("order ".$doWebPaymentParams['order']['ref']." - doWebPayment OK : token ".$doWebPaymentResponse['token']);

				$query = $db->getQuery(true);
				$query->update($db->quoteName($this->_tablename));
				$query->set($db->quoteName('token').' = '.$db->quote($doWebPaymentResponse['token']));
				$query->set($db->quoteName('status').' = '.$db->quote('PENDING'));
				$query->where($db->quoteName('virtuemart_order_id').' = '.$db->quote($virtuemart_order_id));
				$db->setQuery((string)$query);
				$db->query();
				$this->traceQuery($db);

				header("Location: ".$doWebPaymentResponse['redirectURL']);
				exit();
			}else{
				$this->errorMessage = $doWebPaymentResponse['result']['shortMessage'].' (code '.$doWebPaymentResponse['result']['code'].') : '.$doWebPaymentResponse['result']['longMessage'];
				$query = $db->getQuery(true);
				$query->update($db->quoteName($this->_tablename));
				$query->set($db->quoteName('return_code').' = '.$db->quote($doWebPaymentResponse['result']['code']));
				$query->set($db->quoteName('status').' = '.$db->quote('ERR'));
				$query->where($db->quoteName('virtuemart_order_id').' = '.$db->quote($virtuemart_order_id));
				$db->setQuery((string)$query);
				$db->query();
				$this->traceQuery($db);
			}
		}else{
			$this->errorMessage = $doWebPaymentResponse;
		}
		$this->paylineSDK->writeTrace("order ".$doWebPaymentParams['order']['ref']." - ".$this->errorMessage);
		$order['order_status'] = 'X';
		$order['customer_notified'] = 0;
		$order['comments'] = $this->errorMessage;
		$modelOrder = VmModel::getModel ('orders');
		$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
		return $this->processConfirmedOrderPaymentResponse(0, $cart, $order, $this->errorMessage, '');
	}

	function plgVmOnPaymentResponseReceived(&$html) {
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$orderRef = JRequest::getString('on', 0);
		$token = JRequest::getString('token', 0);
		$vendorId = 0;
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null;
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		
		if (!class_exists('VirtueMartModelOrders'))
			require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

		$this->paylineSDK = new paylineSDK(
		$method->merchant_id,
		$method->access_key,
		$method->proxy_host,
		$method->proxy_port,
		$method->proxy_login,
		$method->proxy_password,
		$method->environment
		);

		$getWebPaymentDetailsParam = array('version' => 2, 'token' => $token);
		$getWebPaymentDetailsResponse = $this->paylineSDK->getWebPaymentDetails($getWebPaymentDetailsParam);
		if(isset($getWebPaymentDetailsResponse) && isset($getWebPaymentDetailsResponse['result']['code'])){
			$getWebPaymentDetailsResponseCode = $getWebPaymentDetailsResponse['result']['code'];
			if($orderRef != $getWebPaymentDetailsResponse['order']['ref']){
				$this->paylineSDK->writeTrace("plgVmPaymentPayline::plgVmOnPaymentResponseReceived - rfrence commande ".$getWebPaymentDetailsResponse['order']['ref']." incohrente (attendu : $orderRef.)");
			}
			$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($orderRef);

			if($getWebPaymentDetailsResponseCode == '00000'){
				$this->paylineSDK->writeTrace("order $orderRef - transaction OK : ".$getWebPaymentDetailsResponse['transaction']['id']);

				$db = JFactory::getDBO();
				$query = $db->getQuery(true);
				$query->update($db->quoteName($this->_tablename));
				$query->set($db->quoteName('status').' = '.$db->quote('OK'));
				$query->set($db->quoteName('return_code').' = '.$db->quote('00000'));
				$query->set($db->quoteName('contract').' = '.$db->quote($getWebPaymentDetailsResponse['payment']['contractNumber']));
				$query->set($db->quoteName('transaction').' = '.$db->quote($getWebPaymentDetailsResponse['transaction']['id']));
				if(isset($getWebPaymentDetailsResponse['card'])){
					$query->set($db->quoteName('card_num').' = '.$db->quote($getWebPaymentDetailsResponse['card']['number']));
					$query->set($db->quoteName('card_type').' = '.$db->quote($getWebPaymentDetailsResponse['card']['type']));
					$query->set($db->quoteName('card_exp').' = '.$db->quote($getWebPaymentDetailsResponse['card']['expirationDate']));
				}
				$query->where($db->quoteName('virtuemart_order_id').' = '.$db->quote($virtuemart_order_id));
				$db->setQuery((string)$query);
				$db->query();
				$this->traceQuery($db);
				
				$payment_name = $this->renderPluginName($method);
				$html = $this->_getPaymentResponseHtml($getWebPaymentDetailsResponse, $payment_name);

				if ($virtuemart_order_id) {
					$cart = VirtueMartCart::getCart();
					$cart->emptyCart();
				}
				
				return true;
			}else{
				$comment = $getWebPaymentDetailsResponse['result']['shortMessage']." (code $getWebPaymentDetailsResponseCode) : ".$getWebPaymentDetailsResponse['result']['longMessage'];
				$this->paylineSDK->writeTrace('order '.$orderRef.' - '.$comment);
				
				$db = JFactory::getDBO();
				$query = $db->getQuery(true);
				$query->update($db->quoteName($this->_tablename));
				$query->set($db->quoteName('status').' = '.$db->quote('KO'));
				$query->set($db->quoteName('return_code').' = '.$db->quote($getWebPaymentDetailsResponseCode));
				if(isset($getWebPaymentDetailsResponse['payment']) && isset($getWebPaymentDetailsResponse['payment']['contractNumber'])){
					$query->set($db->quoteName('contract').' = '.$db->quote($getWebPaymentDetailsResponse['payment']['contractNumber']));
				}
				if(isset($getWebPaymentDetailsResponse['transaction']) && isset($getWebPaymentDetailsResponse['transaction']['id'])){
					$query->set($db->quoteName('transaction').' = '.$db->quote($getWebPaymentDetailsResponse['transaction']['id']));
				}
				if(isset($getWebPaymentDetailsResponse['card'])){
					$query->set($db->quoteName('card_num').' = '.$db->quote($getWebPaymentDetailsResponse['card']['number']));
					$query->set($db->quoteName('card_type').' = '.$db->quote($getWebPaymentDetailsResponse['card']['type']));
					$query->set($db->quoteName('card_exp').' = '.$db->quote($getWebPaymentDetailsResponse['card']['expirationDate']));
				}
				$query->where($db->quoteName('virtuemart_order_id').' = '.$db->quote($virtuemart_order_id));
				$db->setQuery((string)$query);
				$db->query();
				$this->traceQuery($db);
				
				$html = JText::_($comment);
				//return false;
				$modelOrder = VmModel::getModel ('orders');
				$order = $modelOrder->getOrder($virtuemart_order_id);
				$order['order_status'] = 'X';
				$order['customer_notified'] = 0;
				$order['comments'] = $comment;
				$modelOrder->updateStatusForOneOrder ($virtuemart_order_id, $order, TRUE);
				$cart = VirtueMartCart::getCart();
				
				return $this->processConfirmedOrderPaymentResponse(0, $cart, $order, $comment, '');
			}
		}else{
			$this->paylineSDK->writeTrace($getWebPaymentDetailsResponse);
			$html = JText::_($getWebPaymentDetailsResponse);
			return false;
		}
	}

	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $payment_method_id) {
		if (!$this->selectedThisByMethodId($payment_method_id)) {
			return null;
		}
		
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->select('*')->from($this->_tablename)->where('virtuemart_order_id='.$virtuemart_order_id);
		$db->setQuery($query);
		if (!($paymentTable = $db->loadObject())) {
			$this->traceQuery($db);
			return '';
		}

		$html = '<table class="adminlist">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_ACTION') . "</td>\n <td align='left'>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_ACTION_'.$paymentTable->action) . "</td>\n</tr>\n";
		$html .= "<tr>\n<td>token</td>\n <td align='left'>" . $paymentTable->token . "</td>\n</tr>\n";
		if($paymentTable->status == 'ERR'){
			$state = JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_ERROR')." (code ".$paymentTable->return_code.")";
		}elseif ($paymentTable->status == 'OK'){
			$state = JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_OK');
		}elseif ($paymentTable->status == 'KO'){
			$state = JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_KO')." (code ".$paymentTable->return_code.")";
		}elseif ($paymentTable->status == 'PENDING'){
			$state = JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_PENDING');
		}
		$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_STATE') . "</td>\n <td align='left'>$state</td>\n</tr>\n";
		$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_TRANSACTION_NUM') . "</td>\n <td align='left'>" . $paymentTable->transaction . "</td>\n</tr>\n";
		$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_PAYMENT_CONTRACT_NUMBER') . "</td>\n <td align='left'>" . $paymentTable->contract . "</td>\n</tr>\n";
		
		if($paymentTable->card_num != 0){
			$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_CARD_NUM') . "</td>\n <td align='left'>" . $paymentTable->card_num . "</td>\n</tr>\n";
			$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_CARD_TYPE') . "</td>\n <td align='left'>" . $paymentTable->card_type . "</td>\n</tr>\n";
			$html .= "<tr>\n<td>" . JFactory::getLanguage()->_('VMPAYMENT_PAYLINE_CARD_EXP') . "</td>\n <td align='left'>" . $paymentTable->card_exp . "</td>\n</tr>\n";
		}
		$html .= '</table>' . "\n";

		return $html;
	}

	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null;
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}

	function plgVmOnShipOrderPayment($order_number) {

		$_paymethodID = $this->getPaymentMethodForOrder($order_number);
		if (!$this->selectedThisMethod($this->_pelement, $_paymethodID)) {
			return null;
		}
		
		$db = JFactory::getDBO();
		
		$query = $db->getQuery(true);
		$query->select('*')->from($this->_tablename)->where('order_number='.$order_number);
		$db->setQuery($query);
		$row = $db->loadResult();
		
		if (!$row) {
			return null;
		}
		
		$this->paylineSDK = new paylineSDK(
			$method->merchant_id,
			$method->access_key,
			$method->proxy_host,
			$method->proxy_port,
			$method->proxy_login,
			$method->proxy_password,
			$method->environment
		);
		
		$doCaptureRequest = array();
		$doCaptureRequest['transactionID'] = '';
		$doCaptureRequest['payment']['amount'] = '';
		$doCaptureRequest['payment']['currency'] = '';
		$doCaptureRequest['payment']['action'] = '';
		$doCaptureRequest['payment']['mode'] = '';
		$doCaptureRequest['payment']['contractNumber'] = '';
		
		// TODO doCapture

		return NULL;
	}

	function _getPaymentResponseHtml($getWebPaymentDetailsResponse, $payment_name) {
		$orderAmount = $getWebPaymentDetailsResponse['order']['amount'] / 100;
		$orderCurrency = $getWebPaymentDetailsResponse['order']['currency'];

		$q  = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `currency_numeric_code`="' . $orderCurrency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$orderCurrencyCodeAlpha = $db->loadResult();

		$formatedAmount = $orderAmount." ".$orderCurrencyCodeAlpha;
		$spacer = "&nbsp;&nbsp;";
		$tdKeyStyle = "style=\"height:20px;font-style:italic;text-align:right\"";
		$tdValueStyle = "style=\"height:20px;font-weight:bold;text-align:left\"";

		$html = "<table>";
		$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_ORDER_REF').$spacer."</td><td $tdValueStyle>".$getWebPaymentDetailsResponse['order']['ref']."</td></tr>";
		$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_ORDER_AMOUNT').$spacer."</td><td $tdValueStyle>".$formatedAmount."</td></tr>";
		$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_TRANSACTION_NUM').$spacer."</td><td $tdValueStyle>".$getWebPaymentDetailsResponse['transaction']['id']."</td></tr>";
		if(isset($getWebPaymentDetailsResponse['card'])){
			$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_CARD_NUM').$spacer."</td><td $tdValueStyle>".$getWebPaymentDetailsResponse['card']['number']."</td></tr>";
			$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_CARD_TYPE').$spacer."</td><td $tdValueStyle>".$getWebPaymentDetailsResponse['card']['type']."</td></tr>";
			$html .= "<tr><td $tdKeyStyle>".JText::_ ('VMPAYMENT_PAYLINE_CARD_EXP').$spacer."</td><td $tdValueStyle>".$getWebPaymentDetailsResponse['card']['expirationDate']."</td></tr>";
		}
		$html.= "</table>";
		$html.= "<br><a href=".JROUTE::_ (JURI::root () . "index.php?option=com_virtuemart").">".JText::_ ('VMPAYMENT_PAYLINE_BACK_HOME')."</a>";

		return $html;
	}

	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
		return $this->onStoreInstallPluginTable($jplugin_id);
	}

	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}

	protected function checkConditions($cart, $method, $cart_prices) {
		return true;
	}

	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}

	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}

	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}

	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}

	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		$this->declarePluginParams('payment', $name, $id, $data);
	}

	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		if (!$this->setOnTablePluginParams($name, $id, $table)) {
			return;
		}
		$virtuemart_paymentmethod_id = JRequest::getVar('virtuemart_paymentmethod_id');
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null;
		}
		$pathfileFileName = $method->pathfile . "pathfile";
		return $pathfileFileName;
	}
}
